******************************************************************************
*  GREENBRS.prg
*  Copyright 1991 by Ian Thurston - but (ab)use this as you will
*  Demonstration of a CLIPPER UDF to simulate GREENBAR paper display of
*  ascii text
*
*  To compile the demo
*        CLIPPER greenbrs
*
*  To link the demo
*        TLINK greenbrs,,,CLIPPER.LIB EXTEND.LIB
*    or  PLINK86 FI greenbrs LIB CLIPPER, EXTEND
*
**** DEMO OF GREENBARS() function ********************************************

SETCOLOR( IIF( ISCOLOR(), "W/B,B/W","W/N,N/W"))
CLEAR
DO WHILE .T.    && pretty shoddy, I know
@ 24,28 say "A Demo of GREENBARS()"
@ 1, 0 SAY REPLICATE( CHR(205),80)
@ 0, 5 PROMPT "Demonstration"
@ 0,25 PROMPT "Source Code"
@ 0,45 PROMPT "Documentation"
@ 0,65 PROMPT "Exit to DOS"
MENU TO h_choice
SAVE SCREEN TO s_greenbars
DO CASE
CASE h_choice = 1   && Do The Demo
    CLEAR
    SET CURSOR OFF
    sample = Memoread("WHATSUP.DOC")    && should be <= 64000 char.
    greenbars( sample, "NEWS.TXT")           && actual function call
    SET CURSOR ON

CASE h_choice = 2
    DO scanfile WITH "GREENBRS.PRG"

CASE h_choice = 3
    DO scanfile WITH "WHATSUP.DOC"

CASE h_choice = 0 .OR. h_choice = 4     && Exit
    @ 20,10 SAY "Thanks for trying 'GREENBARS' (a.k.a. save-a-tree)"
    INKEY(3)
    QUIT
ENDCASE
RESTORE SCREEN FROM s_greenbars
ENDDO

****
PROC scanfile   && Support routine ... GREENBARS() is at the bottom
****
PARAMETERS what2scan
PRIVATE a
IF FILE(what2scan)
    PRIVATE s_scanfile, tempcolor
    SAVE SCREEN TO s_scanfile
    @  2 ,15 SAY "Browse ASCII File: Use cursor keys to move, ESC to Exit"
    @  3,0 SAY REPLICATE( CHR(220), 80)
    @ 23,0 SAY REPLICATE( CHR(223), 80)
    tempcolor=SETCOLOR( SUBSTR(SETCOLOR(), AT(",",SETCOLOR())+1))
    a = MEMOREAD(what2scan)
    MEMOEDIT( substr(a, AT(CHR(42)+ " Copyright",a)), 4, 0, 22, 79, .F.)
    RESTORE SCREEN FROM s_scanfile
    SETCOLOR( tempcolor)
    RELEASE s_scanfile, tempcolor
ENDIF
RETURN

* Here's the meat:
* Copyright 1991 by Ian Thurston
********
FUNCTION greenbars      && simulate greenbar paper
********
*  Calling sequence: [mvar =] GREENBARS( expC1 [, expC2])
*
*  <expC1>   is a character string to be shown
*  <expC1>   is an optional DOS device (file / PRN / COM1: etc.)
*
*  Assumes: Nothing
*
*  Examples:
*   GREENBAR( cVAR )            displays cVAR parsed into 68-character
*                               lines using MEMOLINE's word-wrap
*
*   GREENBAR( cVAR,"NEWS.TXT")  builds NEWS.TXT, a plain ASCII file
*                               with the pin-feed and perfs (no colour)
*
*  Keys:
*   SPACEBAR    pauses / resumes listing
*   ESC         aborts listing

PARAMETERS infile, outfile
IF PCOUNT() < 2
    PRIVATE outfile
    outfile = "CON"
ENDIF
PRIVATE a,perf1, perf2, linecount, tempcolor
perf1 ="|-o-|"
perf2 ="| o |"
linecount = 1
tempcolor=SETCOLOR( IIF(ISCOLOR(),"BG/B","N/W"))
@ 1,0 CLEAR TO 22,79
@ 22,5 SAY ;
     "<SPACEBAR> pauses / Continues   <ESC> quits  <Any other> Fast Scroll"
IF OUTFILE !="CON"
    SET PRINTER TO &outfile
ENDIF
FOR A = 1 TO MLCOUNT(infile, 68, 4, .T.)
    IF A % 10 = 1
		scrollme(perf1 + replicate("-",68) + perf1, @linecount, outfile)
    ENDIF
	scrollme(perf2 + memoline(infile,68,a,4,.T.) + perf2, @linecount, outfile)
    IF LASTKEY() = 27
        EXIT
    ENDIF
NEXT

IF LASTKEY() !=27
    SETCOLOR(IIF(ISCOLOR(),"BG/B","N/W"))
    @ 22,0 CLEAR TO 22,79
    @ 22,30 SAY "Press ESC to exit"
    DO WHILE INKEY(0) !=27
    ENDDO
ENDIF
SETCOLOR(tempcolor)
SET PRINTER TO
RELEASE a, perf1, perf2, linecount, tempcolor
RETURN .T.

FUNCTION scrollme   && subfunction for GREENBRS()
PARAMETERS oneline, linecount, outfile
PRIVATE a
linecount = (linecount + 1) % 4
SCROLL(2,1,21,78,1)
@ 21,1 SAY ""
IF OUTFILE !="CON"
	SET PRINT ON
ENDIF
IF ISCOLOR()
    SETCOLOR( IIF( linecount < 2, "B/BG","B/W"))
ENDIF
?? oneline + IIF(OUTFILE = "CON","",CHR(13)+CHR(10))
SET PRINT OFF
INKEY(.5)                   && p.s. Hold down a key to zoom through
IF LASTKEY() = 32
    DO WHILE INKEY()!=32
    ENDDO
    KEYBOARD CHR(0)
    INKEY()
ENDIF
RETURN .T.

* END FUNCTION greenbars()
